$(function() {
	// placeholder for non html5 browsers
	if (!Modernizr.input.placeholder) {
		$('input[placeholder]').each(function() {
			
			if ($(this).val() == '') {
				$(this).val($(this).attr('placeholder'));
			}
			
			$(this).focus(function() {
				if ($(this).val() == $(this).attr('placeholder')) {
					$(this).val('');
				}		 
			});
			
			$(this).blur(function() {
				if ($(this).val() == '') {
					$(this).val($(this).attr('placeholder'));
				}
			});
		});
	}
	
	// institution autocomplete (registration + profile edit)	
	$('#field-institution').autocomplete({
		source: eval($('#field-institution').attr('data-autocompletion'))
	});
	
	// academic level autocomplete (registration + profile edit)	
	$('#field-academiclevel').autocomplete({
		source: eval($('#field-academiclevel').attr('data-autocompletion'))
	});
	
	// subject search autocomplete	
	$('.field-searchsubject').autocomplete({
		source: eval($('.field-searchsubject').attr('data-autocompletion'))
	});
	
	// confirm delete
	$('a.icon-delete').click(function() {
		return confirm('Are you sure?');								  
	});
	
	// add note form
	$('#form-add-note').hide();
	$('a.icon-add-note').click(function() {
		$('#form-add-note').slideToggle();
		return false;
	});
	
	// note options
	$("#unit-notes article.unit-note").live('mouseover', function(){
        if (!$(this).data('init'))
        {
            $(this).data('init', true);
            $(this).hoverIntent
            (
                function()
                {
                	$(".note-options", this).slideDown();
                },

                function()
                {
                	$(".note-options", this).slideUp();
                }
            );
            $(this).trigger('mouseover');
        }
    });
	
	// note options - reply
	$("#unit-notes article.unit-note .reply a").live('click', function() {
		$("#field-notetype option[value=reply]").remove();
		$("#field-notetype").prepend("<option value=\"reply\">" + eudmlTranslations['details.note.types.REPLY'] + " </option>");
		$("#field-notetype")[0].selectedIndex = 0;
		var noteId = $(this).closest(".unit-note").attr('rel');
		$('#replayToId').attr('value', noteId);
		$('#form-add-note').slideDown();
                $('#note-input').focus();
		return false;
	 });
	
	// suggest subject form
	$('#form-suggest-subject').hide();
	$('a.icon-suggest-subject').click(function() {
		$('#form-suggest-subject').slideToggle();
		return false;									
	});

	/*
	$('.suggest-subject-option2, .suggest-subject-option3').hide();
	$('#field-suggest-subject').bind('focus', function() {
		$('.suggest-subject-option2').fadeIn();
	});
	$('#field-suggest-subject2').bind('change', function() {
		$('.suggest-subject-option3').fadeIn();
	});
	*/
	// add to lists form
	$('#unit-add-to-lists-options').hide();
	$('a.icon-add-to-lists').click(function() {
		$('#unit-add-to-lists-options').slideToggle();
		return false;
	});
	$('#add-to-lists-new-list-name-holder').hide();
	$('#unit-add-to-lists-options select').live('change', function() {
		if( $(this).find('option:selected') ) {
			if( $(this).find(":selected").hasClass('new') ) {
				$('#add-to-lists-new-list-name-holder').show();
			} else {
				$('#add-to-lists-new-list-name-holder').hide();
			}
		}
		return false;
	});
	
	
	// relevancy bar
	if ( $('.similarity-bar').length ) {
		$('.similarity-bar').each(function() {
			var t = $(this);
			t.progressbar({ value: parseInt(t.attr('data-value')) });
		});
	}
	
	// journal page
	$tree = $('#unit-journal-issues section > ul');
	if( $tree ) {
		$('#unit-journal-issues li').has('ul').addClass('toggleable').find('> span').addClass('toggleable');
//		$('#unit-journal-issues li ul').hide();
		/*
		$('#unit-journal-issues li').has('ul').find('> span').click(function(event) {
			if( $(this).find('> a').length ) {
				return true;
			}
			if( $(this).hasClass('toggleable-open') ) {
				$(this).removeClass('toggleable-open');
				$(this).parent().attr('aria-expanded','false');
				$(this).parent().find('> ul').slideUp(200);
			} else {
				$(this).addClass('toggleable-open');
				$(this).parent().attr('aria-expanded','true');
				$(this).parent().find('> ul').slideDown(200);
			}
			event.stopPropagation();
			return false;
		});
        */
		// Add ARIA support for journal page tree
	
		$tree.attr('role','tree');
		$tree.find('li').attr('role','treeitem').attr('aria-expanded','false').attr('tabindex',-1).first().attr('tabindex','0');
		$tree.find('ul').attr('role','group');
		var journalIssueKeys = {
			enter    : 13,
			space    : 32,
			pageup   : 33,
			pagedown : 34,
			end      : 35,
			home     : 36,
			left     : 37,
			up       : 38,
			right    : 39,
			down     : 40,
			asterisk : 106
		};

		// bind a keydown handler to handle tree control keys 
		$tree.keydown(function(e) {

			if (e.altKey || e.ctrlKey || e.shiftKey) { 
				// do nothing 
				return true; 
			}

			// Current focused item
			var $currentItem = $(document.activeElement);
			if( !$currentItem || !($currentItem.parents().is('#unit-journal-issues')) ) {
				return true;
			}

			switch (e.keyCode) {
				case journalIssueKeys.enter    :
				case journalIssueKeys.space    :
					if( $currentItem.find('> span > a').length ) {
						var anchors = $currentItem.find('> span > a');
						if( anchors.length ) {
							window.location.href = anchors.first().attr('href');
						}
						return true;
					} else {
						e.stopPropagation();
						$currentItem.find('> span').click();
						return false;
					}

				case journalIssueKeys.left     :
					e.stopPropagation();
					$currentItem.parent().parent().focus();
					$currentItem = $tree.find('li:focus');
					if( $currentItem.find('> span').hasClass('toggleable-open') ) {
						$currentItem.find('> span').click();
					}
					return false;
				case journalIssueKeys.up       :
					e.stopPropagation();
					$currentItem.prev().focus();
					return false;
				case journalIssueKeys.right    :
					e.stopPropagation();
					if( !$currentItem.find('> span').hasClass('toggleable-open') ) {
						$currentItem.find('> span').click();
					}
					$currentItem.find('> ul > li:first').focus();
					return false;
				case journalIssueKeys.down     :
					e.stopPropagation();
					$currentItem.next().focus();
					return false;
			}
		}); 

		// bind a keypress handler to ignore tree control keys
		$tree.find('li').keypress(function(e) { 
			if (e.altKey || e.ctrlKey || e.shiftKey) { 
				// do nothing
				return true;
			}

			switch (e.keyCode) { 
				case journalIssueKeys.enter: 
				case journalIssueKeys.home: 
				case journalIssueKeys.end: 
				case journalIssueKeys.left: 
				case journalIssueKeys.right: 
				case journalIssueKeys.up: 
				case journalIssueKeys.down:
					e.stopPropagation(); 
					return false; 
			}
			return true;
		});
	}
	$('.jBrowsePerPageForm').change(function(){
		var perPage = $(this).children().filter('[name=results-per-page]').val();
		this.elements['parameterName'].value = 'browse/itemsPerPage';
		this.elements['parameterValue'].value = perPage;
		this.submit();		
	});
        $('.jSearchPerPageForm').change(function(){
		var perPage = $(this).children().filter('[name=results-per-page]').val();
		this.elements['parameterName'].value = 'search/itemsPerPage';
		this.elements['parameterValue'].value = perPage;
		this.submit();
	});
	
	function blinkNoteElement(elem){
		/*
		 jQuery('html, body').animate({
             scrollTop: elem.offset().top - 200
         }, 20);
		*/
		var oldColor = '#F1F1F1';
		elem.find('section.note').stop(true,true).animate({borderColor: "#6FB5FF"}, 250).animate({borderColor: oldColor}, 250).animate({borderColor: "#6FB5FF"}, 250).animate({borderColor: oldColor}, 250);
	}

	$('.jLoadReplay').live('click',function(){
		var senderElement = $(this);
		var responseId = senderElement.attr('rel');
		/*
		if(jQuery('#' + responseId).length > 0){
			blinkNoteElement(jQuery('#' + responseId));
			return false;
		}
		*/
		if(senderElement.data('loaded') == 1){
			var loadedElem = jQuery('#' + senderElement.data('loadedId'));
			blinkNoteElement(loadedElem);
			return false;
		}
		NotesFacade.loadResponseNote(responseId,function(data){
			var sourceTemplate = senderElement.parent().parent().parent();
			
			var newElement = sourceTemplate.clone(true).attr('rel',data.id);
			var newId = new Date().getTime();
			newElement.attr('id', newId);
			var note = newElement.find('section.note');
			var content = data.content;
			if(data.withdrawn){
				content = 'comment withdrawn';
			}
			note.find('p').first().html(content);
			if(data.secondTarget != null){
				note.find('.jLoadReplay').attr('rel', data.secondTarget);
			}else{
				note.find('.jLoadReplay').parent().remove();
			}
			newElement.find('.jAuthor').html(data.author);
			newElement.find('.jDate').html(data.formattedDate);
			newElement.find('.note-options').attr('style','');
			if(!data.removable){
				newElement.find('.remove').remove();
			}else{
				if(newElement.find('.remove').length == 0){
					var remove = jQuery('<li class="remove"><a href="#" class="jRemove">remove this comment</a></li>');
					newElement.find('.note-options').append(remove);
				}
			}
			newElement.insertBefore(sourceTemplate);
			blinkNoteElement(newElement);
			senderElement.data('loaded',1);
			senderElement.data('loadedId', newId);
			sourceTemplate.addClass('child');
		});
		return false;
		
	});
	$('#correction-dialog').dialog({
		autoOpen: false,
		width: 500,
		resizable: false,
		modal: true,
		title: eudmlTranslations['article.details.correction']
	});
	
	$('#suggest-correction').bind('click', function() {
		$('#correction-dialog').dialog('open');
		return false;
	});
	
	$("#unit-notes article.unit-note .flag a").live('click', function(e) {
    	var noteId = $(this).closest(".unit-note").attr('rel');
    	NotesFacade.flagOffensieve(noteId);
    	e.preventDefault();
    	alert('Marked as offensieve.');
    });
	
	$("#unit-notes article.unit-note .remove a").live('click', function(e) {
		var answer = confirm('Are you sure?');
		if(answer){
	    	var noteId = $(this).closest(".unit-note").attr('rel');
	    	NotesFacade.removeNote(noteId,function(data){
	    		var removedNotes = jQuery('[rel=' + noteId + ']');
	    		removedNotes.each(function() {
	    			jQuery(this).find('.note').find('p').first().html('comment withdrawn');
	    			jQuery(this).find('.remove').remove();
	    		});
	    	});
		}
		e.preventDefault();
    });
	
	// Tooltips
	if ($.fn.tipsy) {
		$('.tipsy-tooltip').tipsy();
	}
});
